"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Logger = exports.Log = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _LevelKey;

var _browser = require("tnp-core/browser");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Level;
(function (Level) {
    Level[Level["DATA"] = 0] = "DATA";
    Level[Level["INFO"] = 1] = "INFO";
    Level[Level["WARN"] = 2] = "WARN";
    Level[Level["ERROR"] = 3] = "ERROR";
    Level[Level["__NOTHING"] = 4] = "__NOTHING";
})(Level || (Level = {}));
var LevelKey = (_LevelKey = {}, _defineProperty(_LevelKey, Level.DATA, 'log'), _defineProperty(_LevelKey, Level.INFO, 'info'), _defineProperty(_LevelKey, Level.WARN, 'warn'), _defineProperty(_LevelKey, Level.ERROR, 'error'), _defineProperty(_LevelKey, Level.__NOTHING, ''), _LevelKey);
var LevelOrder = [LevelKey[Level.DATA], LevelKey[Level.INFO], LevelKey[Level.WARN], LevelKey[Level.ERROR]];

var Display = function () {
    function Display() {
        _classCallCheck(this, Display);
    }

    _createClass(Display, null, [{
        key: "msg",
        value: function msg(message, params, moduleName, moduleColor, level, moduleWidth, isProductionMode) {
            if (isProductionMode) {
                return;
            }
            ;
            var color = 'gray';
            if (level === Level.INFO) {
                color = 'deepskyblue';
            }
            if (level === Level.ERROR) {
                color = 'red';
            }
            if (level === Level.WARN) {
                color = 'orange';
            }
            if (moduleWidth) {
                var diff = moduleWidth - moduleName.length;
                if (diff > 0) {
                    for (var i = 0; i < diff; i++) {
                        moduleName += ' ';
                    }
                }
            }
            if (_browser.Helpers.isBrowser) {
                var isEdgeOrIe8orAbove = document['documentMode'] || /Edge/.test(navigator.userAgent);
                if (isEdgeOrIe8orAbove) {
                    if (typeof message === 'string') {
                        var a1 = '[[ ' + moduleName + ' ]] ' + message + ' ';
                        params.unshift(a1);
                    } else {
                        var _a = '[[ ' + moduleName + ']] ';
                        params.push(message);
                        params.unshift(_a);
                    }
                    if (level === Level.INFO) {
                        console.info.apply(console, params);
                    } else if (level === Level.ERROR) {
                        console.error.apply(console, params);
                    } else if (level === Level.WARN) {
                        console.warn.apply(console, params);
                    } else {
                        console.log.apply(console, params);
                    }
                } else {
                    if (typeof message === 'string') {
                        var _a2 = '%c ' + moduleName + '  %c ' + message + ' ';
                        var a2 = 'background: ' + moduleColor + ';color:white; border: 1px solid ' + moduleColor + '; ';
                        var a3 = 'border: 1px solid ' + color + '; ';
                        params.unshift(a3);
                        params.unshift(a2);
                        params.unshift(_a2);
                    } else {
                        var _a3 = '%c ' + moduleName + ' ';
                        var _a4 = 'background: ' + moduleColor + ';color:white; border: 1px solid ' + color + '; ';
                        params.push(message);
                        params.unshift(_a4);
                        params.unshift(_a3);
                    }
                    console.log.apply(console, params);
                }
            }
            if (_browser.Helpers.isNode) {}
        }
    }]);

    return Display;
}();

var Logger = function () {
    function Logger(name, color, developmentMode, allowed, isMuted, fixedWidth) {
        var _this = this;

        _classCallCheck(this, Logger);

        this.name = name;
        this.color = color;
        this.developmentMode = developmentMode;
        this.allowed = allowed;
        this.isMuted = isMuted;
        this.fixedWidth = fixedWidth;
        /** @deprecated Use data(...)
         * @see data
        */
        this.d = function (name) {
            for (var _len = arguments.length, data = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                data[_key - 1] = arguments[_key];
            }

            return _this._data(name, data);
        };
        /** @deprecated Use error(...)
         * @see error
        */
        this.er = function (name) {
            for (var _len2 = arguments.length, data = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                data[_key2 - 1] = arguments[_key2];
            }

            return _this._error(name, data);
        };
        /** @deprecated Use info(...)
         * @see info
        */
        this.i = function (name) {
            for (var _len3 = arguments.length, data = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
                data[_key3 - 1] = arguments[_key3];
            }

            return _this._info(name, data);
        };
        /** @deprecated Use warn(...)
         * @see warn
        */
        this.w = function (name) {
            for (var _len4 = arguments.length, data = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
                data[_key4 - 1] = arguments[_key4];
            }

            return _this._warn(name, data);
        };
        /**
         * Logs message and data with the level=data
         * @param message The message
         * @param otherParams Additional parameters
         */
        this.data = function (message) {
            for (var _len5 = arguments.length, otherParams = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
                otherParams[_key5 - 1] = arguments[_key5];
            }

            return _this._data(message, otherParams);
        };
        /**
         * Logs message and data with the level=error
         * @param message The message
         * @param otherParams Additional parameters
         */
        this.error = function (message) {
            for (var _len6 = arguments.length, otherParams = Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
                otherParams[_key6 - 1] = arguments[_key6];
            }

            return _this._error(message, otherParams);
        };
        /**
         * Logs message and data with the level=info
         * @param message The message
         * @param otherParams Additional parameters
         */
        this.info = function (message) {
            for (var _len7 = arguments.length, otherParams = Array(_len7 > 1 ? _len7 - 1 : 0), _key7 = 1; _key7 < _len7; _key7++) {
                otherParams[_key7 - 1] = arguments[_key7];
            }

            return _this._info(message, otherParams);
        };
        /**
         * Logs message and data with the level=warn
         * @param message The message
         * @param otherParams Additional parameters
         */
        this.warn = function (message) {
            for (var _len8 = arguments.length, otherParams = Array(_len8 > 1 ? _len8 - 1 : 0), _key8 = 1; _key8 < _len8; _key8++) {
                otherParams[_key8 - 1] = arguments[_key8];
            }

            return _this._warn(message, otherParams);
        };
    }

    _createClass(Logger, [{
        key: "setLevel",
        value: function setLevel(l) {
            this._level = l;
            return this;
        }
    }, {
        key: "setProductionMode",
        value: function setProductionMode(productionMode) {
            this.developmentMode = !productionMode;
            return this;
        }
    }, {
        key: "mute",
        value: function mute() {
            this.isMuted = true;
            return this;
        }
    }, {
        key: "onlyWhen",
        value: function onlyWhen(expression) {
            if (typeof expression === 'function') {
                this.isMuted = !expression();
            } else if (typeof expression === 'boolean') {
                this.isMuted = !expression;
            }
        }
    }, {
        key: "_data",
        value: function _data(name) {
            if (this.isMuted) return this;
            if (this.allowed.length >= 1 && _browser.Helpers.contain(this.allowed, Level.__NOTHING) && !_browser.Helpers.contain(this.allowed, Level.DATA)) return this;
            if (this.allowed.length === 0 || _browser.Helpers.contain(this.allowed, Level.DATA)) {
                for (var _len9 = arguments.length, data = Array(_len9 > 1 ? _len9 - 1 : 0), _key9 = 1; _key9 < _len9; _key9++) {
                    data[_key9 - 1] = arguments[_key9];
                }

                Display.msg.apply(void 0, [name].concat(data, [this.name, this.color, Level.DATA, this.fixedWidth, this.isProductionMode]));
            }
            return this;
        }
    }, {
        key: "_error",
        value: function _error(name) {
            if (this.isMuted) return this;
            if (this.allowed.length >= 1 && _browser.Helpers.contain(this.allowed, Level.__NOTHING) && !_browser.Helpers.contain(this.allowed, Level.ERROR)) return this;
            if (this.allowed.length === 0 || _browser.Helpers.contain(this.allowed, Level.ERROR)) {
                for (var _len10 = arguments.length, data = Array(_len10 > 1 ? _len10 - 1 : 0), _key10 = 1; _key10 < _len10; _key10++) {
                    data[_key10 - 1] = arguments[_key10];
                }

                Display.msg.apply(void 0, [name].concat(data, [this.name, this.color, Level.ERROR, this.fixedWidth, this.isProductionMode]));
            }
            return this;
        }
    }, {
        key: "_info",
        value: function _info(name) {
            if (this.isMuted) return this;
            if (this.allowed.length >= 1 && _browser.Helpers.contain(this.allowed, Level.__NOTHING) && !_browser.Helpers.contain(this.allowed, Level.INFO)) return this;
            if (this.allowed.length === 0 || _browser.Helpers.contain(this.allowed, Level.INFO)) {
                for (var _len11 = arguments.length, data = Array(_len11 > 1 ? _len11 - 1 : 0), _key11 = 1; _key11 < _len11; _key11++) {
                    data[_key11 - 1] = arguments[_key11];
                }

                Display.msg.apply(void 0, [name].concat(data, [this.name, this.color, Level.INFO, this.fixedWidth, this.isProductionMode]));
            }
            return this;
        }
    }, {
        key: "_warn",
        value: function _warn(name) {
            if (this.isMuted) return this;
            if (this.allowed.length >= 1 && _browser.Helpers.contain(this.allowed, Level.__NOTHING) && !_browser.Helpers.contain(this.allowed, Level.WARN)) return this;
            if (this.allowed.length === 0 || _browser.Helpers.contain(this.allowed, Level.WARN)) {
                for (var _len12 = arguments.length, data = Array(_len12 > 1 ? _len12 - 1 : 0), _key12 = 1; _key12 < _len12; _key12++) {
                    data[_key12 - 1] = arguments[_key12];
                }

                Display.msg.apply(void 0, [name].concat(data, [this.name, this.color, Level.WARN, this.fixedWidth, this.isProductionMode]));
            }
            return this;
        }
    }, {
        key: "isProductionMode",
        get: function get() {
            return !this.developmentMode;
        }
    }]);

    return Logger;
}();

var Log = function () {
    //#region singleton
    function Log() {
        _classCallCheck(this, Log);

        this._logOnly = false;
        this._logModules = false;
        this.isDevelopmentMode = true;
        this.modeIsSet = false;
        this.fixedWidth = 0;
        this.instances = {};
        this.levels = [];
        this.modules = [];
    }
    // @ts-ignore


    _createClass(Log, [{
        key: "setProductionMode",

        //#region public api
        value: function setProductionMode() {
            var _this2 = this;

            if (this.modeIsSet) {
                this.modeIsSet = false;
                throw '[ng2-logger] Production mode is already set';
            } else {
                this.modeIsSet = true;
                setTimeout(function () {
                    if (_this2.modeIsSet && console !== void 0 && console.clear !== void 0) {
                        console.clear();
                        console.log = function () {};
                        console.error = function () {};
                        console.warn = function () {};
                        console.info = function () {};
                    }
                });
                this.isDevelopmentMode = false;
            }
        }
    }, {
        key: "onlyModules",
        value: function onlyModules() {
            if (this._logModules) {
                throw '[ng2-logger] You should use funcion onlyModules only once';
            }
            if (!this._logModules) {
                this._logModules = true;
            }

            for (var _len13 = arguments.length, modules = Array(_len13), _key13 = 0; _key13 < _len13; _key13++) {
                modules[_key13] = arguments[_key13];
            }

            if (modules.length === 0) return;
            this.modules = modules;
            // console.log('only log this', Log.modules)
            this.muteAllOtherModules();
        }
    }, {
        key: "onlyLevel",
        value: function onlyLevel() {
            if (this._logOnly) {
                throw '[ng2-logger] You should use funcion onlyLevel only once';
            }
            if (!this._logOnly) {
                this._logOnly = true;
            }

            for (var _len14 = arguments.length, level = Array(_len14), _key14 = 0; _key14 < _len14; _key14++) {
                level[_key14] = arguments[_key14];
            }

            this.levels = Array.isArray(level) ? level : [level];
            for (var logName in this.instances) {
                if (this.instances.hasOwnProperty(logName)) {
                    var element = this.instances[logName];
                    element['allowed'] = this.levels;
                }
            }
        }
        //#endregion

    }, {
        key: "create",
        value: function create(name) {
            for (var _len15 = arguments.length, level = Array(_len15 > 1 ? _len15 - 1 : 0), _key15 = 1; _key15 < _len15; _key15++) {
                level[_key15 - 1] = arguments[_key15];
            }

            var i = void 0;
            if (Array.isArray(this.levels) && this.levels.length > 0) {
                level = this.levels;
            }
            if (this.instances[name] === void 0) {
                i = new Log.Logger(name, getRandomColor(), this.isDevelopmentMode, level, this.isMutedModule(name), this.levels.length > 0 ? this.fixedWidth : void 0);
                this.instances[name] = i;
            } else {
                i = this.instances[name];
            }
            return i;
        }
    }, {
        key: "isMutedModule",
        value: function isMutedModule(moduleName) {
            if (this.modules.length == 0) return false;
            if (!_browser.Helpers.contain(this.modules, moduleName)) return true;
            return false;
        }
    }, {
        key: "muteAllOtherModules",
        value: function muteAllOtherModules() {
            for (var moduleName in this.instances) {
                if (!_browser.Helpers.contain(this.modules, moduleName)) this.instances[moduleName].mute();
            }
        }
    }], [{
        key: "create",
        value: function create(name) {
            var _Log$instance;

            for (var _len16 = arguments.length, level = Array(_len16 > 1 ? _len16 - 1 : 0), _key16 = 1; _key16 < _len16; _key16++) {
                level[_key16 - 1] = arguments[_key16];
            }

            return (_Log$instance = Log.instance).create.apply(_Log$instance, [name].concat(level));
        }
    }, {
        key: "disableLogs",
        value: function disableLogs() {
            var _this3 = this;

            var level = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Level.__NOTHING;

            LevelOrder.reverse().find(function (a) {
                if (!_this3.consolelogfn[a]) {
                    _this3.consolelogfn[a] = console[a];
                }
                console[a] = function () {};
                if (a === LevelKey[level]) {
                    return true;
                }
                return false;
            });
        }
    }, {
        key: "enableLogs",
        value: function enableLogs() {
            var _this4 = this;

            LevelOrder.forEach(function (a) {
                console[a] = _this4.consolelogfn[a];
            });
        }
    }, {
        key: "instance",
        get: function get() {
            if (!Log['_instance']) {
                Log['_instance'] = new Log();
            }
            return Log['_instance'];
        }
    }]);

    return Log;
}();
//#endregion


Log.Logger = Logger;
Log.consolelogfn = {};
function getRandomColor() {
    var letters = '012345'.split('');
    var color = '#';
    color += letters[Math.round(Math.random() * 5)];
    letters = '0123456789ABCDEF'.split('');
    for (var i = 0; i < 5; i++) {
        color += letters[Math.round(Math.random() * 15)];
    }
    if (color === void 0) {
        return getRandomColor();
    }
    ;
    return color;
}

/**
 * Generated bundle index. Do not edit.
 */

exports.Log = Log;
exports.Logger = Logger;
//# sourceMappingURL=ng2-logger.js.map